/* this checks return type of declared function against declared value */

DEFINE VARIABLE d AS DECIMAL INITIAL 9223372036854775808 /*2147483648*/.
DEFINE VARIABLE j AS INT64.
FUNCTION fdd RETURNS DECIMAL: RETURN d. END.

/* works as expected, the dynamic decimal result is negated and then
   automatically converted to int64 on return */
FUNCTION f1 RETURNS INT64:   RETURN - DYNAMIC-FUNCTION("fdd"). END.

/* int64 function fails to convert to a 64-bit integer the decimal value.
   strage enought, printing the result you get "-8" ???? */
FUNCTION f2 RETURNS INT64:   RETURN - INT64(d). END.

/* works as expected, the decimal result is negated and then converted 
   to int64 and returned */
FUNCTION f3 RETURNS INT64:   RETURN INT64(- d). END.

/* the dynamic result cannot be stored in some INTEGER container and fails.
   the error message is unable to display the number that caused the error
   and prints "-(" */
FUNCTION f4 RETURNS INTEGER: RETURN - DYNAMIC-FUNCTION("fdd"). END.

/* int64 function fails to convert to a 64-bit integer the decimal value.
   strage enought, printing the result you get "-8" ???? */
FUNCTION f5 RETURNS INTEGER: RETURN - INT64(d). END.

/* the decimal result is negated and then converted to INT64.
   the result is returned as a 64-bit value even if it was declared INTEGER */
FUNCTION f6 RETURNS INTEGER: RETURN INT64(- d). END.

MESSAGE f1().
PAUSE MESSAGE "f1".
MESSAGE f2().
PAUSE MESSAGE "f2".
MESSAGE f3().
PAUSE MESSAGE "f3".
j = f4().
MESSAGE "[" j "|" f4() "]".
PAUSE MESSAGE "f4".
MESSAGE f5().
PAUSE MESSAGE "f5".
MESSAGE f6().
PAUSE MESSAGE "f6".


