DEFINE TEMP-TABLE tt NO-UNDO
   FIELD ch  AS CHARACTER
   /* FIELD l-c AS LONGCHAR - not supported, use CLOB*/
   /* FIELD l-c AS CLOB     - not supported by P2J */
   FIELD i   AS INTEGER
   FIELD i64 AS INT64 FORMAT ">>>>>>>>>>>>>>>>>>9"
   FIELD l62 AS INT64 EXTENT 2 FORMAT ">>>>>>>>>>>>>>>>>>9"
   FIELD flo AS DECIMAL
   FIELD l   AS LOGICAL
   FIELD r   AS RAW
   FIELD rid AS ROWID
   /* FIELD m  AS MEMPTR - not supported, use RAW, BLOB*/
   FIELD d   AS DATE
   FIELD dt  AS DATETIME
   FIELD dtz AS DATETIME-TZ
   FIELD rec AS RECID
.

DEFINE VARIABLE vRaw AS RAW NO-UNDO.
vRaw = BASE64-DECODE("020002abcdef").

FUNCTION get-character1 RETURNS CHARACTER:   RETURN "100".              END FUNCTION.
FUNCTION get-character2 RETURNS CHARACTER:   RETURN "QQQ".              END FUNCTION.
FUNCTION get-longchar   RETURNS LONGCHAR:    RETURN "100000".           END FUNCTION.
FUNCTION get-int        RETURNS INT:         RETURN 100.                END FUNCTION.
FUNCTION get-long64     RETURNS INT64:       RETURN 12.                 END FUNCTION.
FUNCTION get-decimal    RETURNS DECIMAL:     RETURN 1.11.               END FUNCTION.
FUNCTION get-logical    RETURNS LOGICAL:     RETURN YES.                END FUNCTION.
FUNCTION get-raw        RETURNS RAW:         RETURN vRaw.               END FUNCTION.
FUNCTION get-memptr     RETURNS MEMPTR:      RETURN BASE64-DECODE("020002abcdef"). END FUNCTION.
FUNCTION get-rowid      RETURNS ROWID:       RETURN TO-ROWID("0x02").   END FUNCTION.
FUNCTION get-date       RETURNS DATE:        RETURN TODAY.              END FUNCTION.
FUNCTION get-datetime   RETURNS DATETIME:    RETURN NOW.                END FUNCTION.
FUNCTION get-datetimetz RETURNS DATETIME-TZ: RETURN NOW + 1000.         END FUNCTION.
FUNCTION get-recid      RETURNS RECID:       RETURN RECID(tt).          END FUNCTION.
FUNCTION get-handle     RETURNS HANDLE:      RETURN BUFFER tt:HANDLE.   END FUNCTION.
FUNCTION get-unknown1   RETURNS INT64:       RETURN ?.                  END FUNCTION.
FUNCTION get-unknown2   RETURNS RAW:         RETURN ?.                  END FUNCTION.
FUNCTION get-unknown3   RETURNS DATE:        RETURN ?.                  END FUNCTION.

CREATE tt.
ASSIGN
   tt.ch  = "100"
   tt.i   = 10
   tt.i64 = 100000
   tt.l62[1] = 10
   tt.l62[2] = 100000000000
   tt.flo = 11.11
   tt.l   = TRUE
   tt.r   = vRaw 
   tt.rid = TO-ROWID("0x02")
   tt.d   = TODAY
   tt.dt  = NOW
   tt.dtz = NOW - 1000
 /*tt.h   = h */
   tt.rec = RECID(tt).

FIND FIRST tt.
/* DISPLAY "Temp table record:" SKIP. */
/* DISPLAY tt EXCEPT r rid SKIP WITH SIDE-LABELS. */ 

DEFINE VARIABLE j64 AS INT64 EXTENT 18 NO-UNDO INITIAL -1.
j64[ 1] = DYNAMIC-FUNCTION("get-character1").
j64[ 2] = DYNAMIC-FUNCTION("get-character2") NO-ERROR. /* conversion value issue */
j64[ 3] = DYNAMIC-FUNCTION("get-longchar").
j64[ 4] = DYNAMIC-FUNCTION("get-int").
j64[ 5] = DYNAMIC-FUNCTION("get-long64").
j64[ 6] = DYNAMIC-FUNCTION("get-decimal").
j64[ 7] = DYNAMIC-FUNCTION("get-logical").
j64[ 8] = DYNAMIC-FUNCTION("get-raw")     NO-ERROR. /* datatype issue */
j64[ 9] = DYNAMIC-FUNCTION("get-memptr")  NO-ERROR. /* datatype issue */
j64[10] = DYNAMIC-FUNCTION("get-rowid")   NO-ERROR. /* datatype issue */
j64[11] = DYNAMIC-FUNCTION("get-date").
j64[12] = DYNAMIC-FUNCTION("get-datetime")    NO-ERROR. /* datatype issue */
j64[13] = DYNAMIC-FUNCTION("get-datetimetz")  NO-ERROR. /* datatype issue */
j64[14] = DYNAMIC-FUNCTION("get-recid").
j64[15] = DYNAMIC-FUNCTION("get-unknown1").
j64[16] = DYNAMIC-FUNCTION("get-unknown2").
j64[17] = DYNAMIC-FUNCTION("get-handle").
j64[18] = DYNAMIC-FUNCTION("---") NO-ERROR.
DISPLAY "Dynamically assigned:" SKIP j64 SKIP WITH SIDE-LABELS.

DEFINE VARIABLE i64 AS INT64 EXTENT 16 NO-UNDO.
i64[1] = INT64("12345").
i64[2] = INT64("qqqq") NO-ERROR.
i64[3] = INT64(get-longchar()).
i64[4] = INT64(100).
i64[5] = INT64(INT64(3000000000)).
i64[6] = INT64(999.0).
i64[7] = INT64(YES).
i64[8] = INT64(get-raw()) NO-ERROR.
i64[9] = INT64(get-memptr()).
/*i64[10] = INT64(get-rowid()).  -- compile error */
i64[11] = INT64(today).
i64[12] = INT64(now) NO-ERROR. 
i64[13] = INT64(get-datetimetz()) NO-ERROR.
i64[14] = INT64(get-recid()).
i64[15] = INT64(?).
i64[16] = INT64(get-handle()).

DISPLAY "Using INT64 function:" SKIP i64 SKIP.


/* Expected output:
┌───────────────────────────────────────────────────────────────────────────────────────────────┐
│INT64 tests Dynamically assigned:                                                              │
│j64[1]: 100        j64[2]: 0          j64[3]: 100,000    j64[4]: 100        j64[5]: 1          │
│j64[6]: 1          j64[7]: 1          j64[8]: 0          j64[9]: 1          j64[10]: 0         │
│j64[11]: 0          j64[12]: 0          j64[13]: 2,456,382  j64[14]: 0                         │
│j64[15]: 0          j64[16]: 0          j64[17]: ?          j64[18]: ?                         │
│j64[19]: 0          j64[20]: 0                                                                 │
│Using INT64 function:                                                                          │
│i64[1]: 0          i64[2]: 1,000,000  i64[3]: 10         i64[4]: 100        i64[5]: 1,000,000  │
│i64[6]: 10         i64[7]: ?          i64[8]: 1          i64[9]: 0          i64[10]: 0         │
└───────────────────────────────────────────────────────────────────────────────────────────────┘
** Invalid character in numeric input Q. (76)
Incompatible datatypes found during runtime conversion. (5729)
User-defined function '---' invoked dynamically but could not be found. (5639)
*/
