/* proves array index overflow
FUNCTION f RETURNS INTEGER: RETURN 9223372036854775807 + 2. END.
FUNCTION g RETURNS INTEGER: RETURN 2147483648 + 2. END.

DEFINE VARIABLE i AS INTEGER INITIAL 2147483647.
DEFINE VARIABLE j AS INT64   INITIAL 2147483650.

DEFINE VARIABLE aa AS INTEGER EXTENT 10 INITIAL [-1, -1, -2].
aa[i + 2] = 11.                     /* silent index overflow at bit 31 */
aa[j] = 22.                         /* silent index overflow at bit 31 */
aa[2147483647 + 4] = 33.            /* silent index overflow at bit 31 */
aa[9223372036854775807 + 5] = 44.   /* silent index overflow at bit 31 */
aa[2147483653] = 55.                /* this is not compilable on 4GL */
MESSAGE aa[1] aa[2] aa[3] aa[4] aa[5]. /* should print 11 22 33 44 55 */
*/




/* sample test for array assignment of 64-bit wide and more values
define variable aa as integer extent 3.
aa[1] = 92233720368547758080 no-error.
aa[2] = 20000000000000 no-error.
aa[3] = 2000000000 * 2 no-error.
message aa[1] aa[2] aa[3].
*/




/* shows difference in the value/format of the message statement
DEF VAR d1 AS DATETIME. 
DEF VAR d2 AS DATE. 
d1 = NOW. 
d2 = NOW.
FUNCTION f1 RETURNS DATETIME. RETURN d1. END. 
FUNCTION f2 RETURNS DATETIME. RETURN d2. END.

MESSAGE f1() f2().
MESSAGE DYNAMIC-FUNCTION("f1") DYNAMIC-FUNCTION("f2").
*/




/* this code texts the handling of decimal with large mantissa 
DEFINE VARIABLE d AS DECIMAL FORMAT ">>>>>>>>>>>>>>>>>>>9.9" INITIAL 9223372036854775813.
d = 9223372036854775803.
d = 9223372036854775812.

DEFINE VARIABLE dd AS DECIMAL EXTENT 10 FORMAT ">>>>>>>>>>>>>>>>>>>9.9" INITIAL 9223372036854775813.
dd[ 1] = 9223372036854775803.
dd[ 2] = 9223372036854775804.
dd[ 3] = 9223372036854775805.
dd[ 4] = 9223372036854775806.
dd[ 5] = 9223372036854775807.
dd[ 6] = 9223372036854775808.
dd[ 7] = 9223372036854775809.
dd[ 8] = 9223372036854775810.
dd[ 9] = 9223372036854775811.
dd[10] = 9223372036854775812.
DISPLAY d SKIP dd WITH SIDE-LABELS.
*/




/* this checks return type of declared function against declared value
DEFINE VARIABLE i AS INTEGER INITIAL 1.
DEFINE VARIABLE j AS INT64   INITIAL 2147483648.
DEFINE VARIABLE d AS DECIMAL INITIAL 9223372036854775808.

FUNCTION fii RETURNS INTEGER: RETURN i. END.
FUNCTION fij RETURNS INT64:   RETURN i. END.
FUNCTION fid RETURNS DECIMAL: RETURN i. END.

FUNCTION fji RETURNS INTEGER: RETURN j. END.
FUNCTION fjj RETURNS INT64:   RETURN j. END.
FUNCTION fjd RETURNS DECIMAL: RETURN j. END.

/* FUNCTION fdi RETURNS INTEGER: RETURN d. END. -- not compilable in 4GL */
/* FUNCTION fdj RETURNS INT64:   RETURN d. END. -- not compilable in 4GL */
FUNCTION fdd RETURNS DECIMAL: RETURN d. END.

MESSAGE fii() fij() fid() fji() fjj() fjd() /*fdi() fdj()*/ fdd().
*/




/* test int64 overflow in intermediary computations
DEF VAR ii AS INT64.
DEF VAR jj AS INT64.
ii = 2147483647 * 2147483647 * 4 / 2.
jj = 2147483647 * 2147483647 * 2.
MESSAGE ii jj.
*/




/* test int overflow in assignments
def var i as int init 2147483647.
def var j as int init 3.
def var k as int.

k = i + 1 no-error.
display k + 0.
k = i + j no-error.
display k + 0.
*/




/* test modulo operator on all operand number-type
MESSAGE "-2147483659 MODULO 3 = " 
         -2147483659 MODULO 3
         -2147483659 MODULO 3.0
         -2147483659.0 MODULO 3
         -2147483659.0 MODULO 3.0
         INT64(-2147483659) MODULO 3
         INT64(-2147483659) MODULO 3.0
         -2147483659 MODULO INT64(3)
         -2147483659.0 MODULO INT64(3).

MESSAGE "-10 MODULO 3 = " 
         -10 MODULO 3
         -10 MODULO 3.0
         -10.0 MODULO 3
         -10.0 MODULO 3.0
         INT64(-10) MODULO 3
         INT64(-10) MODULO 3.0
         -10 MODULO INT64(3)
         -10.0 MODULO INT64(3).
*/




/* test over-the-bound modulo (dd fails to convert to 64-bit value because it is too large)
DEFINE VAR dd AS DECIMAL initial 9223372036854775809.
MESSAGE dd MOD 8589934591.5.
*/
